//make text for tex
//2013.5.17 arita
#include <iostream>
#include <fstream>
#include "Table.h"
#include "TString.h"


class MakeTex{
private:
   TString text , title , date;
   std::vector< std::vector< TString > > table;

   TString DefaultPreamble( void ){
      TString str;
      str += "\\documentclass{jarticle}\n";
      str += "\\usepackage{graphicx}\n\n";
      str += "\\title{";str += title;str += "}\n";
      str += "\\author{}\n";
      str += "\\date{";str += date;str += "}\n\n\n";
      str += "\\setlength{\\voffset}{0cm}\n";
      str += "\\setlength{\\topmargin}{0cm}\n";
      str += "\\setlength{\\textheight}{22cm}\n";
      str += "\\setlength{\\textwidth}{14.5cm}\n";
      str += "\\setlength{\\oddsidemargin}{1cm}\n";
      str += "\\setlength{\\evensidemargin}{1cm}\n";
      str += "\n\n\n";
      str += "\\begin{document}\n";
      str += "\\maketitle\n\n\n";
      return str;
   };

   TString DefaultTerminate( void ){
      TString str;
      str += "\n\n\\end{document}\n";
      return str;
   };

public:

   MakeTex( void ){
      title = "No title";
      date = "";
   };
   ~MakeTex( void ){};

   void SetTitle( TString str ){title = str;};
   void SetDate( TString str ){date = str;};
   void SetText( TString str ){text = str;};
   void AddText( TString str ){text += str;text += "\n";};

   //don't remove this member function.because of input from stringstream
   void SetTableContent( int row , int col , std::string str ){
      if( (int)table.size() < row+1 ){
         table.resize(row+1);
      }
      if( (int)table[row].size() < col+1 ){
         for( int i = 0;i < (int)table.size();i++){
            table[i].resize(col+1);
            for( int j = 0;j < col+1;j++){
               if( table[i][j].Sizeof() == 1 )table[i][j] = "No Text";
            }
         }
      }

      table[row][col] = str;
   };

   void AddTable( void ){
      TString str = "\\begin{table}[h]\n";
      str += "\\centering \n";
      str += "\\scalebox{0.65}[1]{\n";
      str += "\\begin{tabular}{|";
      if( table.size() == 0 )return;

      for( int col = 0;col < (int)table[0].size();col++){
         str += "c|";
      }
      str += "} \\hline \n";

      for( int row = 0;row < (int)table.size();row++){

         for( int col = 0;col < (int)table[row].size();col++){
            if( col > 0 )str += " & ";
            str += " $ ";
            str += table[row][col];
            str += " $ ";
         }

         if( row == 0 ){
            str += " \\\\ \\hline \\hline \n";
         }else{
            str += " \\\\ \\hline \n";
         }
      }

      str += "\\end{tabular}\n";
      str += "}\n";
      str += "\\end{table}\n";

      text += str;
   };

   void MakeTexFile( TString fname = "tmp.tex" ){
      ofstream ofs( fname );
      ofs << DefaultPreamble() << text << DefaultTerminate() ;
      cout << "[MakeTex]Output tex file : " << fname << endl;
      ofs.close();
   };

};



